﻿//////////////////////////////////////////////
// ClearTargetsPass.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "Pass.h"

#include "../Dll/DllDefines.h"

/// Class ------------------------------------
	
namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT ClearTargetsPass : public Pass
	{
		protected :
		
			// Attributs
			// Les données
			bool _clearColor ;
			bool _clearDepth ;
			float _clearColorValues [4] ;
			unsigned int _targetIndex ;

		protected :

			// Functions
			// Constructor, destructor
			ClearTargetsPass () ;
			virtual ~ClearTargetsPass () ;
		
		public :			

			// Getters
			bool getClearColor () const ;
			bool getClearDepth () const ;
			const float* getClearColorValues () const ;
			float getClearColorValueR () const ;
			float getClearColorValueG () const ;
			float getClearColorValueB () const ;
			float getClearColorValueA () const ;
			unsigned int getTargetIndex () const ;

			// Setters
			void setClearColor (bool value) ;
			void setClearColorValues (float r, float g, float b, float a) ;
			void setClearDepth (bool value) ;
			void setTargetIndex (unsigned int value) ;

			// L'export et import
			virtual void exportClassToTree (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}