﻿//////////////////////////////////////////////
// ShaderMemorySlot.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../../Dll/DllDefines.h"

// nkExport
#include <NilkinsExport/Exportable/Exportable.h>

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <string>

/// Class ------------------------------------
	
namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT ShaderMemorySlot : public nkExport::Exportable
	{
		protected :
		
			// Attributs
			std::string _slotType ;
		
		public :
		
			// Constructeur, destructeur
			ShaderMemorySlot () ;
			virtual ~ShaderMemorySlot () ;

			// Getters
			nkMemory::StringView getSlotType () const ;
			virtual nkMemory::StringView getDataTypeAsString () const = 0 ;

			// Import / export
			virtual void exportClassToTree (nkExport::Node* rootNode) override ;
	} ;
}