﻿//////////////////////////////////////////////
// BmpStandardCompressor.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkImages
{
	class BmpDibHeader ;
	class ImageView ;

	struct AlignmentDescriptor ;
}

/// Includes ---------------------------------

// nkMemory
#include <NilkinsMemory/Containers/Buffer.h>
#include <NilkinsMemory/Containers/BufferView.h>

/// Class ------------------------------------

namespace nkImages
{
	class BmpStandardCompressor final
	{
		private :

			// Constructor, destructor
			BmpStandardCompressor () = delete ;
			~BmpStandardCompressor () = delete ;

		public :

			// Compression
			static unsigned int getCompressedSize (const ImageView& image) ;
			static bool compress (const ImageView& image, nkMemory::BufferView<unsigned char>& output) ;

			// Decompression
			static nkMemory::Buffer decompress (const BmpDibHeader& header, const nkMemory::BufferView<unsigned char>& data, const AlignmentDescriptor& alignmentDescriptor) ;
	} ;
}